<?php
// Version: 2.0 RC2; Recent

function template_main()
{
	global $context, $settings, $options, $txt, $scripturl;

	echo '
	<div id="recent" class="main_section">
		<div class="pagesection">
			<div>', $txt['pages'], ': ', $context['page_index'], '</div>
		</div>';

	foreach ($context['posts'] as $post)
	{
		// This is far from ideal, but oh well - create buttons for the post.
		$button_set = array();

		if ($post['can_delete'])
			$button_set['delete'] = array('text' => 'remove', 'image' => 'delete.gif', 'lang' => true, 'custom' => 'onclick="return confirm(\'' . $txt['remove_message'] . '?\');"', 'url' => $scripturl . '?action=deletemsg;msg=' . $post['id'] . ';topic=' . $post['topic'] . ';recent;' . $context['session_var'] . '=' . $context['session_id']);
		if ($post['can_reply'])
		{
			$button_set['reply'] = array('text' => 'reply', 'image' => 'reply_sm.gif', 'lang' => true, 'url' => $scripturl . '?action=post;topic=' . $post['topic'] . '.' . $post['start']);
			$button_set['quote'] = array('text' => 'reply_quote', 'image' => 'quote.gif', 'lang' => true, 'url' => $scripturl . '?action=post;topic=' . $post['topic'] . '.' . $post['start'] . ';quote=' . $post['id'] . ';' . $context['session_var'] . '=' . $context['session_id']);
		}
		if ($post['can_mark_notify'])
			$button_set['notify'] = array('text' => 'notify_replies', 'image' => 'notify_sm.gif', 'lang' => true, 'url' => $scripturl . '?action=notify;topic=' . $post['topic'] . '.' . $post['start']);

		echo '
		<div class="flow_hidden">
			<h3 class="catbg"><span class="left"></span>
				<span class="align_left">', $post['counter'], ' -&nbsp;</span>
				<span class="align_left">', $post['category']['link'], ' / ', $post['board']['link'], ' / <strong>', $post['link'], '</strong></span>
			</h3>
			<h4 class="titlebg"><span class="left"></span>
				<span class="align_left">', $txt['started_by'], ' ', $post['first_poster']['link'], ' - ', $txt['last_post'], ' ', $txt['by'], ' ', $post['poster']['link'], ' </span>
				<span class="align_right">', $txt['on'], ': ', $post['time'], '</span>
			</h4>
			<div class="windowbg2">
				<span class="topslice"><span></span></span>
				<div class="content">
					', $post['message'], '
				</div>
				<span class="botslice"><span></span></span>
			</div>';

		if (!empty($button_set))
			template_button_strip($button_set, 'right');

		echo '
			<br class="clear" />
		</div>';
	}

	echo '
		<div class="pagesection">
			<div class="align_left">', $txt['pages'], ': ', $context['page_index'], '</div>
		</div>
	</div>';
}

function template_unread()
{
	global $context, $settings, $options, $txt, $scripturl, $modSettings;

	$showCheckboxes = !empty($options['display_quick_mod']) && $options['display_quick_mod'] == 1 && $settings['show_mark_read'];

	if ($showCheckboxes)
		echo '
	<div id="recent" class="main_content">';

	if ($settings['show_mark_read'])
	{
		// Generate the button strip.
		$mark_read = array(
			'markread' => array('text' => !empty($context['no_board_limits']) ? 'mark_as_read' : 'mark_read_short', 'image' => 'markread.gif', 'lang' => true, 'url' => $scripturl . '?action=markasread;sa=' . (!empty($context['no_board_limits']) ? 'all' : 'board' . $context['querystring_board_limits']) . ';' . $context['session_var'] . '=' . $context['session_id']),
		);

		if ($showCheckboxes)
			$mark_read['markselectread'] = array(
				'text' => 'quick_mod_markread',
				'image' => 'markselectedread.gif',
				'lang' => true,
				'url' => 'javascript:document.quickModForm.submit();',
			);
	}

	echo '
			<div class="pagesection">				
				<div class="middletext pagelinks">', $txt['pages'], ': ', $context['page_index'], '</div>';

	if (!empty($mark_read) && !empty($settings['use_tabs']))
		template_button_strip($mark_read, 'right');

	echo '
			</div>';

		echo '
			<div class="tborder topic_table" id="unread">';

	foreach ($context['topics'] as $topic)
	{
		// Calculate the color class of the topic.
		$color_class = 'windowbg';
		if (strpos($topic['class'], 'sticky') !== false)
			$color_class = ' stickybg';
		if (strpos($topic['class'], 'locked') !== false)
			$color_class .= ' lockedbg';

		$color_class2 = !empty($color_class) ? $color_class . '2' : '';

		echo '
			', $topic['is_sticky'] ? '<strong>' : '', '<span id="msg_' . $topic['first_post']['id'] . '">', $topic['first_post']['link'], '</span>', $topic['is_sticky'] ? '</strong>' : '';

		// Is this topic new? (assuming they are logged in!)
		echo '
			&nbsp;<a href="', $topic['new_href'], '" id="newicon' . $topic['first_post']['id'] . '"><img src="', $settings['lang_images_url'], '/new.gif" alt="', $txt['new'], '" /></a>';

		// Start all the *description* or *content* or *information* or *uber-awesome-pwnage* section
		echo '
			<p class="', $color_class, ' message_info">
				<img src="', $settings['images_url'], '/topic/', $topic['class'], '.gif" alt="" />
				<img src="', $topic['first_post']['icon_url'], '" alt="" />
				<br />', $txt['started_by'], ' ', $topic['first_post']['member']['link'], '
				<small id="pages' . $topic['first_post']['id'] . '">', $topic['pages'], '</small>
				<br />', $topic['replies'], ' ', $txt['replies'], '	', $topic['views'], ' ', $txt['views'], '
			</p>';

	}

	if (!empty($context['topics']) && !$context['showing_all_topics'])
		$mark_read['readall'] = array('text' => 'unread_topics_all', 'image' => 'markreadall.gif', 'lang' => true, 'url' => $scripturl . '?action=unread;all' . $context['querystring_board_limits'], 'active' => true);

	echo '
			</div>
			<div class="pagesection" id="readbuttons">
				<div class="middletext pagelinks">', $txt['pages'], ': ', $context['page_index'], '</div>';

	if (!empty($settings['use_tabs']) && !empty($mark_read))
		template_button_strip($mark_read, 'right');

	echo '
			</div>
	';

	echo '
	</div>';
}

function template_replies()
{
	global $context, $settings, $options, $txt, $scripturl, $modSettings;

	$showCheckboxes = !empty($options['display_quick_mod']) && $options['display_quick_mod'] == 1 && $settings['show_mark_read'];

	if ($showCheckboxes)
		echo '
	<div id="recent">';

	if (isset($context['topics_to_mark']) && !empty($settings['show_mark_read']))
	{
		// Generate the button strip.
		$mark_read = array(
			'markread' => array('text' => 'mark_as_read', 'image' => 'markread.gif', 'lang' => true, 'url' => $scripturl . '?action=markasread;sa=unreadreplies;topics=' . $context['topics_to_mark'] . ';' . $context['session_var'] . '=' . $context['session_id']),
		);

		if ($showCheckboxes)
			$mark_read['markselectread'] = array(
				'text' => 'quick_mod_markread',
				'image' => 'markselectedread.gif',
				'lang' => true,
				'url' => 'javascript:document.quickModForm.submit();',
			);
	}

	echo '
		<div class="pagesection">
			<div class="pagelinks">', $txt['pages'], ': ', $context['page_index'], '</div>';

	if (!empty($mark_read) && !empty($settings['use_tabs']))
		template_button_strip($mark_read, 'right');

	echo '
		</div>';

	echo '
		<div class="tborder topic_table" id="unreadreplies">';

	foreach ($context['topics'] as $topic)
	{
		// Calculate the color class of the topic.
		$color_class = 'windowbg';
		if (strpos($topic['class'], 'sticky') !== false)
			$color_class = ' stickybg';
		if (strpos($topic['class'], 'locked') !== false)
			$color_class .= ' lockedbg';

		$color_class2 = !empty($color_class) ? $color_class . '2' : '';

		echo '
			', $topic['is_sticky'] ? '<strong>' : '', '<span id="msg_' . $topic['first_post']['id'] . '">', $topic['first_post']['link'], '</span>', $topic['is_sticky'] ? '</strong>' : '';

		// Is this topic new? (assuming they are logged in!)
		echo '
			&nbsp;<a href="', $topic['new_href'], '" id="newicon' . $topic['first_post']['id'] . '"><img src="', $settings['lang_images_url'], '/new.gif" alt="', $txt['new'], '" /></a>';

		// Start all the *description* or *content* or *information* or *uber-awesome-pwnage* section
		echo '
			<p class="', $color_class, ' message_info">
				<img src="', $settings['images_url'], '/topic/', $topic['class'], '.gif" alt="" />
				<img src="', $topic['first_post']['icon_url'], '" alt="" />
				<br />', $txt['started_by'], ' ', $topic['first_post']['member']['link'], '
				<small id="pages' . $topic['first_post']['id'] . '">', $topic['pages'], '</small>
				<br />', $topic['replies'], ' ', $txt['replies'], '	', $topic['views'], ' ', $txt['views'], '
			</p>';

	}

	echo '
		</div>
			<div class="pagesection">
				<div class="middletext pagelinks">', $txt['pages'], ': ', $context['page_index'], '</div>';

	if (!empty($settings['use_tabs']) && !empty($mark_read))
		template_button_strip($mark_read, 'right');

	echo '
			</div>';
}

?>